#---------------------------------------------------------------------------#
#          Copyright (c) 1997-2011 PDFlib GmbH. All rights reserved.        #
#---------------------------------------------------------------------------#
#    This software may not be copied or distributed except as expressly     #
#    authorized by PDFlib GmbH's general license agreement or a custom      #
#    license agreement signed by PDFlib GmbH.                               #
#    For more information about licensing please refer to www.pdflib.com.   #
#---------------------------------------------------------------------------#

# $Id: PLOP.pm,v 1.15 2014/11/18 10:28:03 rjs Exp $
#
package PDFlib::PLOP;

use strict;
use Carp;

use plop_pl 5.0;
our $VERSION = 5.0;

sub new {
    my $class = shift;
    my $self = {};
    my $plop = PLOP_new();

    bless $self, $class;
    $self->{plop} = $plop;
    PLOP_set_option($plop,  "objorient=true");

    return $self;
}

sub DESTROY {
    my $self = shift;

    PLOP_delete($self->{plop});
}

# Automatically generated methods


sub close_document {
    my $self = shift;
    eval {
	PLOP_close_document($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
}

sub convert_to_unicode {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_convert_to_unicode($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub create_document {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_create_document($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub create_pvf {
    my $self = shift;
    eval {
	PLOP_create_pvf($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
}

sub delete_pvf {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_delete_pvf($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub get_apiname {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_get_apiname($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub get_buffer {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_get_buffer($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub get_errmsg {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_get_errmsg($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub get_errnum {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_get_errnum($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub info_pvf {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_info_pvf($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub open_document {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_open_document($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub pcos_get_number {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_pcos_get_number($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub pcos_get_stream {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_pcos_get_stream($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub pcos_get_string {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_pcos_get_string($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub prepare_signature {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_prepare_signature($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub set_option {
    my $self = shift;
    eval {
	PLOP_set_option($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
}
